/**
 * initApp handles setting up UI event listeners and registering Firebase auth listeners:
 *  - firebase.auth().onAuthStateChanged: This listener is called when the user is signed in or
 *    out, and that is where we update the UI.
 */

 let email;
 let uid;
 
 function initApp() {
     // Listening for auth state changes.
     // [START authstatelistener]
     firebase.auth().onAuthStateChanged(function (user) {
         if (user) {
             // User is signed in.


 
             email = user.email;
             let emailVerified = user.emailVerified;
             uid = user.uid;
             let providerData = user.providerData;
 
              console.log(user.metadata.lastSignInTime);
             let db = firebase.firestore();
 
 
             let docRef = db.collection("branches").doc(uid);
 
             docRef.get().then(function (doc) {
                 if (doc.exists) {
                  
                    let restName = doc.data().branch;
                    let traderName = doc.data().managerFullName;
                    let restId = doc.data().restId;
                    let branchId = doc.data().branchId;
                    document.getElementById('proName').innerText = traderName+" ("+restName+")";
                    db.collection("meals").where("restId", "==", restId).onSnapshot((snapshot) => {
                        console.log("Barnches: " + snapshot.size)
                        document.getElementById('totalBranches').innerText = snapshot.size;
                        snapshot.forEach(function (document) {
        
                          
                        });
                       
                    });
                    db.collection("menus").where("restId", "==", restId).onSnapshot((snapshot) => {
                        document.getElementById('totalMenus').innerText = snapshot.size;
                        snapshot.forEach(function (document) {
        
                          
                        });
                       
                    });
                   
                    db.collection("orders").where("branchId", "==", branchId).onSnapshot((snapshot) => {
                        document.getElementById('totalOrders').innerText = snapshot.size;
                        snapshot.forEach(function (document) {
        
                          
                        });
                       
                    });
                    db.collection("reviews").where("branchId", "==", branchId).onSnapshot((snapshot) => {
                        snapshot.forEach(function (documents) {
                            var div = document.getElementById('custReviews');
                            if(documents.data().rating === 1){
                                div.innerHTML = '<div class="box p-0">'+
                            ' <div class="box-body">'+
                                '<div class="d-flex align-items-center">'+
                                '  <div class="review-tx">'+
                                    ' <div class="d-flex mb-10">'+
                                        '  <div>'+
                                            '  <p class="mb-0">'+documents.data().ratedByName+' to '+documents.data().branch+'</p>'+
                                                '<p class="mb-0"><small class="text-mute">'+documents.data().ratingTime.toDate()+'</small></p> </div>'+
                                            ' </div>'+
                                        ' <p class="mb-10">'+documents.data().ratingComment+'</p>'+
                                        '  <div class="d-flex text-warning align-items-center">'+
                                        '<i class="fa fa-star"></i>'+
                                            '<i class="fa fa-star-o"></i>'+
                                            ' <i class="fa fa-star-o"></i>'+
                                            '  <i class="fa fa-star-o"></i>'+
                                            '  <i class="fa fa-star-o"></i>'+
                                            '   <span class="text-fade ms-10">'+documents.data().rating+'</span>'+
                                            ' </div>'+
                                        ' </div>'+
                                    '  <img src="../images/food/dish-1.png" class="dish-img" alt="" />'+
                                    ' </div>'+
                                ' </div>'+
                        '</div>'

                            }else if(documents.data().rating === 2){
                                div.innerHTML = '<div class="box p-0">'+
                            ' <div class="box-body">'+
                                '<div class="d-flex align-items-center">'+
                                '  <div class="review-tx">'+
                                    ' <div class="d-flex mb-10">'+
                                        '  <div>'+
                                            '  <p class="mb-0">'+documents.data().ratedByName+' to '+documents.data().branch+'</p>'+
                                                '<p class="mb-0"><small class="text-mute">'+documents.data().ratingTime.toDate()+'</small></p> </div>'+
                                            ' </div>'+
                                        ' <p class="mb-10">'+documents.data().ratingComment+'</p>'+
                                        '  <div class="d-flex text-warning align-items-center">'+
                                        '<i class="fa fa-star"></i>'+
                                            '<i class="fa fa-star"></i>'+
                                            ' <i class="fa fa-star-o"></i>'+
                                            '  <i class="fa fa-star-o"></i>'+
                                            '  <i class="fa fa-star-o"></i>'+
                                            '   <span class="text-fade ms-10">'+documents.data().rating+'</span>'+
                                            ' </div>'+
                                        ' </div>'+
                                    '  <img src="../images/food/dish-1.png" class="dish-img" alt="" />'+
                                    ' </div>'+
                                ' </div>'+
                        '</div>'
                            }else if(documents.data().rating === 3){
                                div.innerHTML = '<div class="box p-0">'+
                            ' <div class="box-body">'+
                                '<div class="d-flex align-items-center">'+
                                '  <div class="review-tx">'+
                                    ' <div class="d-flex mb-10">'+
                                        '  <div>'+
                                            '  <p class="mb-0">'+documents.data().ratedByName+' to '+documents.data().branch+'</p>'+
                                                '<p class="mb-0"><small class="text-mute">'+documents.data().ratingTime.toDate()+'</small></p> </div>'+
                                            ' </div>'+
                                        ' <p class="mb-10">'+documents.data().ratingComment+'</p>'+
                                        '  <div class="d-flex text-warning align-items-center">'+
                                        '<i class="fa fa-star"></i>'+
                                            '<i class="fa fa-star"></i>'+
                                            ' <i class="fa fa-star"></i>'+
                                            '  <i class="fa fa-star-o"></i>'+
                                            '  <i class="fa fa-star-o"></i>'+
                                            '   <span class="text-fade ms-10">'+documents.data().rating+'</span>'+
                                            ' </div>'+
                                        ' </div>'+
                                    '  <img src="../images/food/dish-1.png" class="dish-img" alt="" />'+
                                    ' </div>'+
                                ' </div>'+
                        '</div>'
                            }else if(documents.data().rating === 4){
                                div.innerHTML = '<div class="box p-0">'+
                            ' <div class="box-body">'+
                                '<div class="d-flex align-items-center">'+
                                '  <div class="review-tx">'+
                                    ' <div class="d-flex mb-10">'+
                                        '  <div>'+
                                            '  <p class="mb-0">'+documents.data().ratedByName+' to '+documents.data().branch+'</p>'+
                                                '<p class="mb-0"><small class="text-mute">'+documents.data().ratingTime.toDate()+'</small></p> </div>'+
                                            ' </div>'+
                                        ' <p class="mb-10">'+documents.data().ratingComment+'</p>'+
                                        '  <div class="d-flex text-warning align-items-center">'+
                                        '<i class="fa fa-star"></i>'+
                                            '<i class="fa fa-star"></i>'+
                                            ' <i class="fa fa-star"></i>'+
                                            '  <i class="fa fa-star"></i>'+
                                            '  <i class="fa fa-star-o"></i>'+
                                            '   <span class="text-fade ms-10">'+documents.data().rating+'</span>'+
                                            ' </div>'+
                                        ' </div>'+
                                    '  <img src="../images/food/dish-1.png" class="dish-img" alt="" />'+
                                    ' </div>'+
                                ' </div>'+
                        '</div>'
                            }else if(documents.data().rating === 5){
                                div.innerHTML = '<div class="box p-0">'+
                            ' <div class="box-body">'+
                                '<div class="d-flex align-items-center">'+
                                '  <div class="review-tx">'+
                                    ' <div class="d-flex mb-10">'+
                                        '  <div>'+
                                            '  <p class="mb-0">'+documents.data().ratedByName+' to '+documents.data().branch+'</p>'+
                                                '<p class="mb-0"><small class="text-mute">'+documents.data().ratingTime.toDate()+'</small></p> </div>'+
                                            ' </div>'+
                                        ' <p class="mb-10">'+documents.data().ratingComment+'</p>'+
                                        '  <div class="d-flex text-warning align-items-center">'+
                                        '<i class="fa fa-star"></i>'+
                                            '<i class="fa fa-star"></i>'+
                                            ' <i class="fa fa-star"></i>'+
                                            '  <i class="fa fa-star"></i>'+
                                            '  <i class="fa fa-star"></i>'+
                                            '   <span class="text-fade ms-10">'+documents.data().rating+'</span>'+
                                            ' </div>'+
                                        ' </div>'+
                                    '  <img src="../images/food/dish-1.png" class="dish-img" alt="" />'+
                                    ' </div>'+
                                ' </div>'+
                        '</div>'
                            }

            

                          
                        });
                       
                    });
                    
 
 
                 } else {
                    Swal.fire({
                        icon: 'error',
                        title: 'Oops...',
                        text: 'You don not have access to this platform.'

                    });
                    toggleSignOut()
                     // doc.data() will be undefined in this case
                     console.log("No such document!");
                 }
             }).catch(function (error) {
                 console.log("Error getting document:", error);
             });
 
 
 
         } else {
             // User is signed out.
             console.log("User is signed out");
             window.location.href = 'index.html'
 
         }
 
     });
     // [END authstatelistener]
 
 }
 
 window.onload = function () {
     initApp();
 };
 
 
 
 function toggleSignOut() {
 
     // [START signout]
     firebase.auth().signOut();
     // [END signout]
 
 }
 
 $(document).on("keydown",function(e){
 
    var keyCode = e.which || e.keyCode;
    if(keyCode == 13) // enter key code
    {
       toggleSignIn();
    }
 
 });