/**
 * initApp handles setting up UI event listeners and registering Firebase auth listeners:
 *  - firebase.auth().onAuthStateChanged: This listener is called when the user is signed in or
 *    out, and that is where we update the UI.
 */

 let email;
 let uid;
 
 function initApp() {
     // Listening for auth state changes.
     // [START authstatelistener]
     firebase.auth().onAuthStateChanged(function (user) {
         if (user) {
             // User is signed in.


 
             email = user.email;
             let emailVerified = user.emailVerified;
             uid = user.uid;
             let providerData = user.providerData;
 
              console.log(user.metadata.lastSignInTime);
             let db = firebase.firestore();
 
 
             let docRef = db.collection("branches").doc(uid);
            
             docRef.get().then(function (doc) {
                 if (doc.exists) {
                    let resRef = db.collection("restaurants").doc(doc.data().restId);
                    let restName = doc.data().restaurant;
                    let traderName = doc.data().managerFullName;
                    let branchName = doc.data().branch;
                    let branchId = doc.data().branchId;

                    document.getElementById('proName').innerText = traderName+" ("+branchName+")";
                    resRef.get().then(function (doc) {
                        if (doc.exists) {
                                console.log(doc.data().latitude+" "+doc.data().longitude)
                            var mapProp= {
                                center:new google.maps.LatLng(doc.data().latitude,doc.data().longitude),
                                zoom:12,
                                mapTypeId: google.maps.MapTypeId.ROADMAP,
                              };
                              var map = new google.maps.Map(document.getElementById("googleMap"),mapProp);
                              var marker = new google.maps.Marker({
                                position:new google.maps.LatLng(doc.data().latitude,doc.data().longitude),
                                icon: "../images/placeholder.png"
                              });
                              
                              marker.setMap(map);
         
                              
                              db.collection("orders").where("branchId", "==", branchId).onSnapshot((snapshot) => {
                                
                                 snapshot.forEach(function (document) {
                                   
                                    
                                     let deliveryLat = document.data().deliveryLat;
                                     let deliveryLng= document.data().deliveryLng;
                                     var marker = new google.maps.Marker({
                                        position:new google.maps.LatLng(deliveryLat,deliveryLng),
                                      
                                      });
                                      
                                      marker.setMap(map);
                 
                 
                                     
                                 });
        
                               
                                
                             });
        
        
        
                        } else {
                            Swal.fire({
                                icon: 'error',
                                title: 'Oops...',
                                text: 'You don not have access to this platform.'
        
                            });
                            toggleSignOut()
                            // doc.data() will be undefined in this case
                            console.log("No such document!");
                        }
                    }).catch(function (error) {
                        console.log("Error getting document:", error);
                    });
                   
                    
 
 
                 } else {
                    Swal.fire({
                        icon: 'error',
                        title: 'Oops...',
                        text: 'You don not have access to this platform.'

                    });
                    toggleSignOut()
                     // doc.data() will be undefined in this case
                     console.log("No such document!");
                 }
             }).catch(function (error) {
                 console.log("Error getting document:", error);
             });
 
 
 
         } else {
             // User is signed out.
             console.log("User is signed out");
             window.location.href = 'index.html'
 
         }
 
     });
     // [END authstatelistener]
 
 }

 function myMap() {
    
    }
 
 window.onload = function () {
     initApp();
 };
 
 
 
 function toggleSignOut() {
 
     // [START signout]
     firebase.auth().signOut();
     // [END signout]
 
 }
 
 $(document).on("keydown",function(e){
 
    var keyCode = e.which || e.keyCode;
    if(keyCode == 13) // enter key code
    {
       toggleSignIn();
    }
 
 });