/**
 * initApp handles setting up UI event listeners and registering Firebase auth listeners:
 *  - firebase.auth().onAuthStateChanged: This listener is called when the user is signed in or
 *    out, and that is where we update the UI.
 */

let email;
let uid;
let db;
let traderName;
let restName;
let restId;
let branchId;
let branchName;

$(document).ready(function () {

});


function initApp() {
    // Listening for auth state changes.
    // [START authstatelistener]
    firebase.auth().onAuthStateChanged(function (user) {
        if (user) {
            // User is signed in.

            email = user.email;
            let emailVerified = user.emailVerified;
            uid = user.uid;
            let providerData = user.providerData;

            console.log(uid)
            db = firebase.firestore();
            let traderRef = db.collection("branches").doc(uid);


            traderRef .get().then(function (doc) {
                if (doc.exists) {

                 
                    traderName = doc.data().managerFullName;
                    branchName = doc.data().branch;
                    branchId = doc.data().branchId;
                    console.log(doc.id, " => ", doc.data());
                     restName = doc.data().restaurant;
                     restId = doc.data().restId;


                    document.getElementById('proName').innerText = traderName + " (" + branchName + ")";
                    db.collection("users").where("typeId", "==", 2).where("branchId", "array-contains", branchId).orderBy('timestamp', 'desc').onSnapshot((snapshot) => {
                        $("#riders tbody").empty();
                        snapshot.forEach(function (document) {

                            let riderName = document.data().displayName;
                            let riderPhone = document.data().phoneNumber;
                            let riderEmail = document.data().email;
                            let riderReg = document.data().registration;
                            let riderDate = document.data().timestamp.toDate();
                            let riderDelStatus = document.data().deliveryStatus;
                            let riderStatus = document.data().status;
                            let riderStatusId = document.data().statusCode;

                            let riderLicense = document.data().driverLicense;


                            var body = "<tr>";

                            body += "<td>" + riderReg + "</td>";
                            body += "<td>" + riderName + "</td>";
                            body += "<td>" + riderPhone + "</td>";
                            body += "<td>" + riderEmail + "</td>";
                            body += "<td><img class=\"\img-fluid\" src=" + riderLicense + " alt=\"NotAvailable\"  width=\"400\" height=\"500\" ></td>";

                            body += "<td>" + riderDate + "</td>";

                            body += "<td>" + riderDelStatus + "</td>";
                            if (riderStatusId == 1) {
                                body += "<td><span class=\"badge badge-boxed badge-success\">" + riderStatus + "</span></td>";


                                body += '<td><div class="row card-body"><button  id=' + document.id + ' class="btn btn-primary" data-bs-toggle="modal" data-bs-target="#exampleModalform3" onclick ="disableRider(this.id)">Disable</button><button  id=' + document.id + ' class="btn btn-danger" data-bs-toggle="modal" data-bs-target="#exampleModalform4" onclick ="deleteRider(this.id)">Delete</button></div></td>';

                            } else {

                                body += "<td><span class=\"badge badge-boxed badge-danger\">" + riderStatus + "</span></td>";

                                body += '<td><div class="row card-body"><button  id=' + document.id + ' class="btn btn-info" data-bs-toggle="modal" data-bs-target="#exampleModalform2" onclick ="enableRider(this.id)">Approve</button><button  id=' + document.id + ' class="btn btn-danger" data-bs-toggle="modal" data-bs-target="#exampleModalform4" onclick ="deleteRider(this.id)">Delete</button></div></td>';
                            }
                            body += "</tr>"
                            $("#riders tbody").append(body);
                        });

                        if (!$.fn.DataTable.isDataTable('#riders')) {
                            $('#riders').DataTable({
                                dom: 'Bfrtip',
                                buttons: [
                                    'copy', 'csv', 'excel', 'pdf', 'print'
                                ]
                            });
                        }

                    });



                } 
            }).catch(function (error) {
                console.log("Error getting document:", error);
            });


         
                    


               










        } else {
            // User is signed out.
            console.log("User is signed out");
            window.location.href = 'index.html'

        }

    });
    // [END authstatelistener]

}

window.onload = function () {
    initApp();
};



function toggleSignOut() {

    // [START signout]
    firebase.auth().signOut();
    // [END signout]

}

$(document).on("keydown", function (e) {

    var keyCode = e.which || e.keyCode;
    if (keyCode == 13) // enter key code
    {
        toggleSignIn();
    }

});


function openDetails(id) {

    //window.location.href = "shop_details.html?shopId=" + id

}


function enableRider(id) {
    console.log(id);


    let element = document.getElementById('approve-rider');
   
    element.addEventListener("click", function () {
        let reason = document.getElementById('approveReason').value;
        if (reason.length < 1) {
    
    
            Swal.fire({
                icon: 'error',
                title: 'Oops...',
                text: 'Please enter a valid reason.'
    
            })
            return;
        }
        $("#approve-rider").attr("disabled", true);
        db.collection("users").doc(id).update({
            status: "Active", statusCode: 1, isApproved: true, reason: reason

        }).then(() => {
            console.log("Document successfully updated!");
            $('#exampleModalform2').modal('hide');
            $("#approve-rider").attr("disabled", false);
        })
            .catch((error) => {
                $("#approve-rider").attr("disabled", false);
                // The document probably doesn't exist.
                console.error("Error updating document: ", error);
            });
    });

}
function disableRider(id) {
    console.log(id);
    let element = document.getElementById('disapprove-rider');
 
    element.addEventListener("click", function () {
        let reason = document.getElementById('disableReason').value;
        if (reason.length < 1) {
    
    
            Swal.fire({
                icon: 'error',
                title: 'Oops...',
                text: 'Please enter a valid reason.'
    
            })
            return;
        }
        $("#disapprove-rider").attr("disabled", true);
        db.collection("users").doc(id).update({
            status: "Inactive", statusCode: 0, isApproved: false, reason: reason

        }).then(() => {
            console.log("Document successfully updated!");
            $('#exampleModalform3').modal('hide');
            $("#disapprove-rider").attr("disabled", false);
        })
            .catch((error) => {
                $("#disapprove-rider").attr("disabled", false);
                // The document probably doesn't exist.
                console.error("Error updating document: ", error);
            });
    });
}
function deleteRider(id) {
    console.log(restId);
  
       
    let element = document.getElementById('delete-rider');
    
    element.addEventListener("click", function () {
        $("#delete-rider").attr("disabled", true);
        db.collection("users").doc(id).update({
            restId: firebase.firestore.FieldValue.arrayRemove(restId),
            restaurant: firebase.firestore.FieldValue.arrayRemove(restName),
         

        }).then(() => {
            console.log("Document successfully updated!");
            $('#exampleModalform4').modal('hide');
            $("#delete-rider").attr("disabled", false);
        })
            .catch((error) => {
                $("#delete-rider").attr("disabled", false);
                // The document probably doesn't exist.
                console.error("Error updating document: ", error);
            });
        });
    
    

    }