/**
 * initApp handles setting up UI event listeners and registering Firebase auth listeners:
 *  - firebase.auth().onAuthStateChanged: This listener is called when the user is signed in or
 *    out, and that is where we update the UI.
 */

let email;
let uid;

let traderName;




function initApp() {
    // Listening for auth state changes.
    // [START authstatelistener]
    firebase.auth().onAuthStateChanged(function (user) {
        if (user) {
            // User is signed in.

            email = user.email;
            let emailVerified = user.emailVerified;
            uid = user.uid;
       
            let providerData = user.providerData;

             console.log(uid)
            let db = firebase.firestore();

            let traderRef = db.collection("branches").doc(uid);


            traderRef .get().then(function (doc) {
                if (doc.exists) {

                 
                    traderName = doc.data().traderFullName;



                } 
            }).catch(function (error) {
                console.log("Error getting document:", error);
            });


            let docRef = db.collection("restaurants").where("tradersIdArray", "array-contains", uid);

            docRef.get().then((querySnapshot) => {
                querySnapshot.forEach((doc) => {
                    // doc.data() is never undefined for query doc snapshots
                    console.log(doc.id, " => ", doc.data());
                   let  restName = doc.data().restaurant;
                   let restId = doc.data().restId;
                
               
                    document.getElementById('proName').innerText = traderName + " (" + restName + ")";
                    db.collection("branches").where("restId", "==", restId).orderBy('timestamp', 'desc').onSnapshot((snapshot) => {
                        snapshot.forEach(function (document) {
        
                            let stName = document.data().branch;
                            let stAddress = document.data().branchAddress;
                            let stEmail = document.data().branchEmail;
                            let stPhone = document.data().branchPhone;
                            let stRest = document.data().restaurant;
                            let stStatus = document.data().status;
        
        
                            var body = "<tr>";
        
                            body += "<td>" + stName + "</td>";
                            body += "<td>" + stAddress + "</td>";
                            body += "<td>" + stRest + "</td>";
                            body += "<td>" + stPhone + "</td>";
                            body += "<td>" + stEmail + "</td>";
                            body += "<td>" + stStatus + "</td>";
                            body += '<td><div class="row card-body"><button  id=' + document.id + ' class="btn btn-primary"  onclick ="openDetails(this.id)">View/Edit</button></div></td>';
                            body += "</tr>"
                            $("#shops tbody").append(body);
                        });
                        $('#shops').DataTable({
                            dom: 'Bfrtip',
                            buttons: [
                                'copy', 'csv', 'excel', 'pdf', 'print'
                            ]
                        });
                    });

                 
                });
        
                   
            }).catch(function (error) {
                console.log("Error getting document:", error);
            });

          








        } else {
            // User is signed out.
            console.log("User is signed out");
            window.location.href = 'index.html'

        }

    });
    // [END authstatelistener]

}

window.onload = function () {
    initApp();
};



function toggleSignOut() {

    // [START signout]
    firebase.auth().signOut();
    // [END signout]

}

$(document).on("keydown", function (e) {

    var keyCode = e.which || e.keyCode;
    if (keyCode == 13) // enter key code
    {
        toggleSignIn();
    }

});


function openDetails(id) {

    window.location.href = "shop_details.html?shopId=" + id

}